      program tll 
      implicit double precision (a-h,o-z)
      parameter (nbmax=4000)
      parameter (nrp=20)
      real*8 H(nbmax,nbmax),Z(3),PR(nbmax),ONE(nbmax),S(nbmax)
      real*8 G(nbmax),RX(nbmax),RY(nbmax),TAU(nbmax)
      real*8 X(nbmax,2),JX(nbmax,nbmax),JY(nbmax,nbmax)
      complex*16 QZ,U(nbmax,nbmax)
      integer LI(nbmax,2)
      real*8  X1(nbmax), X2(nbmax), Y1(nbmax), Y2(nbmax)
      real*8  px1, px2, py1, py2
c     for the lapack
      integer INFO, LDZ
      character JOBZ, UPLO
      real*8 W(nbmax),EIG(nbmax,nbmax),WORK(nbmax*3)
      real*8 AP(nbmax*(nbmax+1)/2), Jz

      disorder=0.5

c     Hamiltonian parameters, number of repeat, disorder:
c     Z(1),Z(2),Z(3),nrp,disorder

      call CPU_TIME (t1)
c=================================================================================================================
      open (unit=30,file='coordinates.dat')
      open (unit=31,file='connectivity.dat')
      open (unit=32,file='pbc.dat')

      open (unit=41,file='unavgd_tll.dat')
      open (unit=42,file='avgd_tll.dat')
      open (unit=43,file='cpu_time.dat')

c     Read the connectivity 
      il=0
      read (31,*)N
  5   read (31,*,END=8)k,l,m
      il=il+1
      LI(il,1)=k 
      LI(il,2)=l 
      go to 5
  8   continue
      rewind (31)
c     Read the coordinates 
      do i=1,N
       read (30,*)X(i,1),X(i,2)
      enddo
c     Read the Periodic Boundary Condition(PBC)
      read (32,*)px1,py1
      read (32,*)px2,py2
c     Save coordiantes (X,Y) of sites
      do i=1,il
       X1(i)=X(LI(i,1),1)
       X2(i)=X(LI(i,2),1)
       Y1(i)=X(LI(i,1),2)
       Y2(i)=X(LI(i,2),2)
      enddo
c     Compute the distance between sites (RX, RY) considering pbc
      call Distance(X1,X2,Y1,Y2,px1,py2,RX, RY,il)
c     il is the number of non zero off-diagonal matrix element (counted once)
c==================================================================================================================
c     the cycle over iang (the angle of the cross section) which explores the meridian of the sphere
c     the cycle over IQ repeat for some realizations of disorder (max:nrp)
      do iang=0,24,1 
c===============
       QL2=0.
c==================================
            dO IQ=1,nrp
              write (*,*)iang,IQ

       ang=iang*7.5/57.29577
       Z(1)=0.1*cos(ang)
       Z(2)=(0.1/sqrt(2.))*sin(ang)
       Z(3)=(0.1/sqrt(2.))*sin(ang)

c Z(1), Z(2), Z(3) : different electronic couplings
c for real material one can use the data obtained form ab-initio calculations

c        Jz=sqrt(Z(1)**2+Z(2)**2+Z(3)**2)
c        write(*,*) 'Coupling magnitude=', Jz
c------------------------------Constructing the Hamiltonian--------------------------------     
      rewind (31) 
c     size of the electrical Hamiltonian
      read (31,*)N

      do i=1,N
       do j=1,N
        H(i,j)=0.
       enddo
      enddo
      il=0
  10  continue
      read (31,*,END=20)k,l,m
      il=il+1
      H(k,l)=Z(m)*(1+disorder*rgau())
      H(l,k)=H(k,l)
      TAU(il)=H(k,l)
      go to 10
  20  continue
c     il is the number of non zero off-diagonal matrix element (counted once)

c------------------------------Hamiltonian Diagonalization--------------------------------     
      JOBZ='V'
      UPLO='L'
      LDZ=nbmax
      ic=0
      do j=1,N
       do i=j,N
        ic=ic+1
        AP(ic)=H(i,j)
       enddo
      enddo
 186  format (206F5.0)
      call DSPEV( JOBZ, UPLO, N, AP, W, EIG, LDZ, WORK, INFO )
c------------------------------Calculation of Current--------------------------------------
c  compute the quantity |<n|J|m>|^2 whenre n and m are eigenvectors
c  and J is the operator -i Sum_ij ( R_i - R_j ) t_ij
      do i=1,N
       do j=i,N
        SX=0.
        SY=0.
c        instead of iterating over the sites we iterate
c        over the non-zero matrix elements
          do k=1,il
            SX=SX+ EIG(LI(k,1),i) * EIG(LI(k,2),j) * RX(k) * TAU(k) 
     .           - EIG(LI(k,2),i) * EIG(LI(k,1),j) * RX(k) * TAU(k) 

            SY=SY+ EIG(LI(k,1),i) * EIG(LI(k,2),j) * RY(k) * TAU(k) 
     .           - EIG(LI(k,2),i) * EIG(LI(k,1),j) * RY(k) * TAU(k) 
           enddo
         JX(i,j)=SX**2
         JX(j,i)=SX**2
         JY(i,j)=SY**2
         JY(j,i)=SY**2
       enddo
      enddo
c---------------Thermal Averaging With Proper Inter-energy Weighting-----------------------
      ZZ=0.
      SX=0.
      SY=0.
      beta=0.025
      p2=0.000025
c beta: thermal energy
c p=hbar/Tau (Tau=0.13 ps)
      do i=1,N
       BOL=exp((W(i)-W(1))/beta)
       ZZ=ZZ+BOL
       do j=1,N
        SX=SX + BOL * JX(i,j)*2 / (p2+(W(i)-W(j))**2) 
        SY=SY + BOL * JY(i,j)*2 / (p2+(W(i)-W(j))**2) 
       enddo
      enddo

      write (41,*)ang,(SX+SY)/(2.*ZZ),SX/ZZ,SY/ZZ
      QL2=QL2+((SX+SY)/(2.*ZZ))

c   QL2 averaged localization length (L^2)
c   SX/ZZ,SY/ZZ are respectively Lx^2 and Ly^2
c=============
        enddo
      write (42,*) ang,QL2/nrp
c===============================
      enddo
c==================
      call CPU_TIME (t2)
      write(43,*) t2-t1, "second"
      end

c==================================================================================================================
c this subroutine computes the distance between the sites
c considering Periodic Boundary Condition      
      subroutine Distance(tX1,tx2,tY1,tY2,x1,y2,RX,RY,n)
      real*8 tX1(n),tX2(n), XX2(n)
      real*8 tY1(n),tY2(n)
      real*8 RX(n), RY(n)
      real*8 x1, y2
      integer n
      do i=1,n
       RXX=tX1(i)-tX2(i)
       if (RXX.gt.x1/2) then
        RXX=RXX-x1
       else if (RXX.lt.-x1/2) then
        RXX=RXX+x1
       endif 
       RX(i)=RXX
       RYY=tY1(i)-tY2(i)
       if (RYY.gt.y2/2) then
        RYY=RYY-y2
       else if (RYY.lt.-y2/2) then
        RYY=RYY+y2
       endif 
       RY(i)=RYY
      enddo
      return
      end
c--------------------------------------------------------------------------------
c this function generates a number distributed as in a
c gaussian distribution centered on x=0 and with variance
c sigma=1
      real*8 function rgau()
      w=2.
c from http://www.taygeta.com/random/gaussian.html
      do while ( w.gt.1.0 )
       x1=2.*rand(0)-1.0
       x2=2.*rand(0)-1.0
       w= x1*x1 + x2*x2
      enddo
      w=sqrt( (-2*log(W) ) / W );
      y1=x1*w
      y2=x2*w
c
      rgau=y1
      return
      end 
c================================================================================================================== 
